package be.iminds.ilabt.jfed.rspec.model.javafx_impl;

import be.iminds.ilabt.jfed.rspec.model.GeantTestbedType;
import be.iminds.ilabt.jfed.rspec.model.WebVncService;
import be.iminds.ilabt.jfed.util.GeniUrn;
import javafx.beans.property.*;
import javafx.collections.FXCollections;
import javafx.collections.ObservableList;

import java.util.List;
import java.util.Objects;

/**
 * User: twalcari
 * Date: 5/22/2015
 * Time: 10:38
 */
public class FXGeantTestbedType implements GeantTestbedType {
    private final ObjectProperty<GeniUrn> componentManagerId = new SimpleObjectProperty<>();
    private final ObjectProperty<GeniUrn> componentId = new SimpleObjectProperty<>();
    private final ObjectProperty<GeniUrn> sliverId = new SimpleObjectProperty<>();

    private final StringProperty name = new SimpleStringProperty();
    private final StringProperty dsl = new SimpleStringProperty();

    private final DoubleProperty editorX = new SimpleDoubleProperty();
    private final DoubleProperty editorY = new SimpleDoubleProperty();

    private final ObjectProperty<VpnService> vpnService = new SimpleObjectProperty<>();
    private final ObservableList<WebVncService> webVncServices = FXCollections.observableArrayList();

    private final ObservableList<ActiveExternalDomain> activeExternalDomains = FXCollections.observableArrayList();

    public FXGeantTestbedType() {
    }

    public FXGeantTestbedType(String name) {
        this.name.setValue(name);
    }

    public FXGeantTestbedType(GeantTestbedType gtt) {
        setName(gtt.getName());
        setDsl(gtt.getDsl());
        setComponentManagerId(gtt.getComponentManagerId());
        setComponentId(gtt.getComponentId());
        setSliverId(gtt.getSliverId());

        setEditorX(gtt.getEditorX());
        setEditorY(gtt.getEditorY());
        setVpnService(gtt.getVpnService());
        setWebVncServices(gtt.getWebVncServices());
    }

    @Override
    public String getDsl() {
        return dsl.get();
    }

    public StringProperty dslProperty() {
        return dsl;
    }

    public void setDsl(String dsl) {
        this.dsl.set(dsl);
    }

    @Override
    public double getEditorX() {
        return editorX.get();
    }

    public DoubleProperty editorXProperty() {
        return editorX;
    }

    public void setEditorX(double editorX) {
        this.editorX.set(editorX);
    }

    @Override
    public double getEditorY() {
        return editorY.get();
    }

    public DoubleProperty editorYProperty() {
        return editorY;
    }

    public void setEditorY(double editorY) {
        this.editorY.set(editorY);
    }

    @Override
    public String getName() {
        return name.get();
    }

    public StringProperty nameProperty() {
        return name;
    }

    public void setName(String name) {
        this.name.set(name);
    }


    @Override
    public GeniUrn getComponentManagerId() {
        return componentManagerId.get();
    }

    public ObjectProperty<GeniUrn> componentManagerIdProperty() {
        return componentManagerId;
    }

    public void setComponentManagerId(GeniUrn componentManagerId) {
        this.componentManagerId.set(componentManagerId);
    }

    @Override
    public GeniUrn getComponentId() {
        return componentId.get();
    }

    public ObjectProperty<GeniUrn> componentIdProperty() {
        return componentId;
    }

    public void setComponentId(GeniUrn componentId) {
        this.componentId.set(componentId);
    }

    @Override
    public GeniUrn getSliverId() {
        return sliverId.get();
    }

    public ObjectProperty<GeniUrn> sliverIdProperty() {
        return sliverId;
    }

    public void setSliverId(GeniUrn sliverId) {
        this.sliverId.set(sliverId);
    }

    @Override
    public VpnService getVpnService() {
        return vpnService.get();
    }

    public ObjectProperty<VpnService> vpnServiceProperty() {
        return vpnService;
    }

    public void setVpnService(VpnService vpnService) {
        this.vpnService.set(vpnService);
    }

    @Override
    public ObservableList<WebVncService> getWebVncServices() {
        return webVncServices;
    }

    @Override
    public void setWebVncServices(List<WebVncService> webVncServices) {
        this.webVncServices.setAll(webVncServices);
    }

    @Override
    public void addWebVncService(WebVncService webVncService) {
        this.webVncServices.add(webVncService);
    }

    public ObservableList<ActiveExternalDomain> getActiveExternalDomains() {
        return activeExternalDomains;
    }

    public static class ActiveExternalDomain {
        private final String gtsLocation;
        private final String gtsPortId;

        public ActiveExternalDomain(String gtsLocation, String gtsPortId) {
            this.gtsLocation = gtsLocation;
            this.gtsPortId = gtsPortId;
        }

        public String getGtsLocation() {
            return gtsLocation;
        }

        public String getGtsPortId() {
            return gtsPortId;
        }
    }

    public static class GtsVlan {
        private final String gtsLocation;
        private final String gtsPortId;
        private final GeniUrn vlanUrn;
        private final String rspecNodeName;

        private GtsVlan(String gtsLocation, String gtsPortId, GeniUrn vlanUrn, String rspecNodeName) {
            this.gtsLocation = gtsLocation;
            this.gtsPortId = gtsPortId;
            this.vlanUrn = vlanUrn;
            this.rspecNodeName = rspecNodeName;
        }

        public String getGtsLocation() {
            return gtsLocation;
        }

        public String getGtsPortId() {
            return gtsPortId;
        }

        public GeniUrn getVlanUrn() {
            return vlanUrn;
        }

        public String getRspecNodeName() {
            return rspecNodeName;
        }
    }



}
